package graphTest;

import java.util.HashSet;
import java.util.Set;
import it.unical.mat.jdlv.program.JDLV_Logger;
import it.unical.mat.jdlv.util.JdlvProperties;

public  class Graph{

private Set<Arc> arcs= new HashSet<Arc>();
private Set<String> nodes= new HashSet<String>();
public Graph(){
for(int i= 1 ;i<= 10 ;i++)
{
addNode( "n" +i);
}
addArc( new Arc( "n2" , "n4" ));
addArc( new Arc( "n2" , "n3" ));
addArc( new Arc( "n3" , "n5" ));
addArc( new Arc( "n4" , "n6" ));
addArc( new Arc( "n4" , "n5" ));
addArc( new Arc( "n5" , "n7" ));
addArc( new Arc( "n6" , "n8" ));
addArc( new Arc( "n6" , "n7" ));
addArc( new Arc( "n7" , "n9" ));
addArc( new Arc( "n8" , "n10" ));
addArc( new Arc( "n8" , "n9" ));
addArc( new Arc( "n9" , "n1" ));
addArc( new Arc( "n10" , "n1" ));
for(Colored col:compute3Coloring())
{
System.out.println(col);
}
}
public  void  addNode(String id){
nodes.add(id);
}
public  void  addArc(Arc arc){
arcs.add(arc);
}
public Set<Colored> compute3Coloring(){
Set<Colored> res= new HashSet<Colored>();

	// ---- START - startProgram ---- 
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logInfoMessage("Creation program JDLV module.");
it.unical.mat.wrapper.DLVInputProgram _JDLV_PROGRAM_program=new it.unical.mat.wrapper.DLVInputProgramImpl();
_JDLV_PROGRAM_program.cleanText();
java.lang.StringBuffer _JDLV_PROGRAM_BUFFER_program=new java.lang.StringBuffer();
it.unical.mat.wrapper.DLVInvocation _JDLV_INVOCATION_program;

	// ---- END - startProgram ---- 

	// ---- START - addInMapping ---- 
_JDLV_PROGRAM_program.addText(it.unical.mat.jdlv.program.TypeSolver.getNameTranslation(arcs,"arc"));
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logInfoMessage("Add in-mapping 'arcs::arc' in module program:"+ it.unical.mat.jdlv.program.JDLV_Logger.getInstance().getPrettyCode(it.unical.mat.jdlv.program.TypeSolver.getNameTranslation(arcs,"arc"), 0));
_JDLV_PROGRAM_program.addText(it.unical.mat.jdlv.program.TypeSolver.getNameTranslation(nodes,"node"));
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logInfoMessage("Add in-mapping 'nodes::node' in module program:"+ it.unical.mat.jdlv.program.JDLV_Logger.getInstance().getPrettyCode(it.unical.mat.jdlv.program.TypeSolver.getNameTranslation(nodes,"node"), 0));

	// ---- END - addInMapping ---- 
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logInfoMessage("Add out-mapping 'res::col' in module program.");

	// ---- START - prepareJDLVCall ---- 
try{

_JDLV_INVOCATION_program=it.unical.mat.wrapper.DLVWrapper.getInstance().createInvocation(it.unical.mat.jdlv.util.JdlvProperties.getInstance().getDlvExecutablePath());
_JDLV_PROGRAM_program.addText(_JDLV_PROGRAM_BUFFER_program.toString());
_JDLV_PROGRAM_program.addText("col(X, red) v col(X, green) v col(X, blue) :- node(X)."+'\n');
_JDLV_PROGRAM_program.addText(":- col(X, C), col(Y, C), arc(X, Y)."+'\n');
_JDLV_PROGRAM_program.getFiles().clear();
_JDLV_INVOCATION_program.setNumberOfModels(1);
_JDLV_PROGRAM_BUFFER_program.append("");
_JDLV_INVOCATION_program.setInputProgram(_JDLV_PROGRAM_program);
it.unical.mat.wrapper.ModelBufferedHandler _BUFFERED_HANDLER_program=new it.unical.mat.wrapper.ModelBufferedHandler(_JDLV_INVOCATION_program);
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logInfoMessage("Start execution program program: executablePath='"+it.unical.mat.jdlv.util.JdlvProperties.getInstance().getDlvExecutablePath()+"', options='"+_JDLV_INVOCATION_program.getOptionsString()+"'"+'\n'+"Code execution: "+it.unical.mat.jdlv.program.JDLV_Logger.getInstance().getPrettyCode(_JDLV_INVOCATION_program.getInputProgram().getCompleteText(),0));
_JDLV_INVOCATION_program.run();
while(_BUFFERED_HANDLER_program.hasMoreModels()){
it.unical.mat.wrapper.Model _temporary_JDLV_MODELprogram=_BUFFERED_HANDLER_program.nextModel();
it.unical.mat.jdlv.program.TypeSolver.loadPredicate(res, "col",_temporary_JDLV_MODELprogram,Colored.class);
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logInfoMessage("Process new answer_set"+ '\n' + "Results:"+ '\n'+ "res " + res.size() + " elements"+ '\n' + it.unical.mat.jdlv.program.JDLV_Logger.getInstance().getPrettyObject(res,0));
}
if(_JDLV_INVOCATION_program.haveModel()==false){
}
if(!_JDLV_INVOCATION_program.getErrors().isEmpty()){
throw new java.lang.RuntimeException(_JDLV_INVOCATION_program.getErrors().get(0).getText());
}
}
catch(java.lang.Throwable _JDLV_EXCEPTION_program){
it.unical.mat.jdlv.program.JDLV_Logger.getInstance().logErrorMessage(_JDLV_EXCEPTION_program.getMessage());
}
_JDLV_PROGRAM_program.cleanText();

	// ---- END - prepareJDLVCall ---- 
return res;
}
public static  void  main(String[] args){
 new Graph();
}
}

